;****************************************************************************
;*                     GNU Hell on Earth   ver 0.16 Beta                    *
;*                    A 3D engine for the TI 92 calculator                  *
;*                     Copyright (C) 1998  Mathieu Lacage                   *
;****************************************************************************

 ifeq wall_texturing-off

   move.w   D5,D6            ; top->D2
   asr.w    #1,D6
   move.w   #height/2,D2
   sub.w    D6,D2
if_2_2:
   cmp      #0,D2
   bge      \wall_not_too_big
\wall_too_big
   move     #0,D2
   move.w   #height,d5        ; bottom->d5
   bra      end_top_bottom
\wall_not_too_big
   add.w    D2,D5             ; bottom->D5

end_top_bottom:

if_4_2:
   tst      D3
   bne      plot
end_if_4_2:

line:
   mulu     #30,D2
   add.l    plane_ptr,D2
   move.l   D2,A5
   mulu     #30,D5
   add.l    plane_ptr,D5
   move.l   D0,D6
   move.l   D0,D3
   asr      #3,D3
   and      #8-1,D6
   bitchg   d6,d3
   add.l    D3,A5
   add.l    D3,D5
iter_10:
   bset.b   D6,(a5)
   cmp.l    D5,A5
   beq      end
   add.l    #30,A5
   bra      iter_10
end_line:
   bra      end

plot:
   mulu.w   #30,D2
   add.l    plane_ptr,D2
   move.l   d2,a5
   move.w   D0,D3
   asr.w    #3,D3
   move.w   D0,D6
   and.w    #8-1,D6
   bitchg   d6,d3
   bset.b   D6,0(a5,d3)
   mulu.w   #30,D5
   move.l   plane_ptr,a5
   add.l    D3,D5
   bset.b   D6,0(A5,d5)                
end_plot:
   bra      end

 endif


 ifeq wall_texturing-on
  ifeq wall_opti-on

   cmp      #height,D5
   bge      wall_textures_big
   move.w   D5,D6            ; top->D2
   asr.w    #1,D6
   move.w   #height/2,D2
   sub.w    D6,D2

   cmp      #texturing_limit,d5
   ble      wall_textures_small
   bra      wall_textures_normal

wall_textures_big:

tex_loop     macro
\@loop                              ;
   move.w  d2,d5                    ;
   asr.w   #8-_wall_texture_size,d5 ;
   and.w   #~(1<<_wall_texture_size-1),d5
   btst.b  d3,0(a1,d5)              ; a texturing routine in draw.asm
   beq     \@white                  ;
\@black                             ;
   bset.b  d6,(a2)                  ;
\@white                             ;
   add.w   d4,d2                    ;
   add.l   #30,a2                   ;
             endm

mu30     macro        ; This macro will multiply \1 by 30=1<<5-2
   move.\0  \1,\2     ; thus, 30*y=y*1<<5-y*2=y<<5-2*y=2*(y<<4-y)     
   asl.\0   #4,\2     ; or 30*y=(y<<4-y)<<1
   sub.\0   \1,\2     ; The result is located in \2
   asl.\0   #1,\2     ;
         endm         ;

\init
   movem.l d0-d4,-(a7)
   move.l  plane_ptr,a2             ;
   move.w  d0,d6                    ;
   asr.w   #3,d0                    ;  adress of begening in a2 
   add.l   d0,a2                    ;  ( adress in the screen )
   and.w   #8-1,d6                  ;  number of bit to set in screen in d6.b
   tst.b   d6
   bne     \else1
   sub.w   #1,a2
   bra     \end_if1
\else1
   move.w  #8,d0
   sub.w   d6,d0
   move.w  d0,d6
\end_if1

   move.l  #wall_texture_size*256,d4   ;  step * 256 -> d4.w
   divu.w  d5,d4                    ;
   ext.l   d4
   move.w  d4,d2                    ;
   mulu.w  #height,d2               ;

   move.w  #wall_texture_size/2,d5
   asr.w   #8,d2
   asr.w   #1,d2
   sub.w   d2,d5
   asl.l   #_wall_texture_size,d5
   ext.l   d5

   lea     textures(pc),a1         ;
   add.l   d5,a1                   ;
   move.w  d3,d1                   ;
   asr.w   #3,d1                   ;  adress of begening in texture
   ext.l   d1                      ;  in a1 
   add.l   d1,a1                   ;
   and.w   #8-1,d3                 ;  and bit to test in texture in d3.b
   tst.b    d3
   bne      \else2
   sub.w    #1,a1
   bra      \end_if2
\else2
   move.w   #8,d0
   sub.w    d3,d0
   move.w   d0,d3
\end_if2

   clr.w    d2

   repeat   height,<tex_loop>

   movem.l (a7)+,d0-d4
   bra end
end_wall_textures_big:

wall_textures_normal:


   move.w   d5,-(a7)
   add.w    D2,D5             ; bottom->D5

\init
   movem.l d0-d4,-(a7)
   lea     textures(pc),a1         ;
   move.w  d3,d6                   ;
   asr.w   #3,d6                   ;  adress of begening in texture
   ext.l   d6                      ;  in a1 
   and.w   #8-1,d3                 ;  and bit to test in texture in d3.b
   bitchg  d3,d6
   add.l   d6,a1                   ;

   move.l  plane_ptr,a2             ;
   move.w  d0,d6                    ;
   asr.w   #3,d0                    ;
   add.l   d0,a2                    ;
   and.w   #8-1,d6                  ;  adresses of begening in a2 and of end

   tst.b    d6
   bne      \else4
   sub.w    #1,a2
   bra      \end_if4
\else4
   move.w   #8,d0
   sub.w    d6,d0
   move.w   d0,d6
\end_if4

   move.l  a2,a3                    ;  number of bit to set in screen in d6.b
   mu30.w  d2,d4
   add.l   d4,a2                    ;
   mu30.w  d5,d2
   ext.l   d2
   add.l   d2,a3                    ;

   move.w  #wall_texture_size*256,d4   ;  step * 256 -> d4.w
   move.w  5*4(a7),d2
   divu.w  d2,d4                    ;
   ext.l   d4                       ;

   clr.w   d2

   repeat texturing_limit-1,<tex_loop>

loop

   tex_loop

   cmp.l   a2,a3
   bne     loop
   movem.l (a7)+,d0-d4
   add.l   #2,a7
   bra end
end_wall_textures_normal:


wall_textures_small:
   add.w    D2,D5             ; bottom->D5

   mu30.w   d2,d6
   ext.l    d6
   add.l    plane_ptr,D6
   move.l   d6,a5
   move.w   D0,D3
   asr.w    #3,D3
   move.w   D0,D6
   and.w    #8-1,D6
   bitchg   d6,d3
   bset.b   D6,0(a5,d3)
   mu30.w   d5,d2
   ext.l    d2
   move.l   plane_ptr,a5
   add.l    D3,D2
   bset.b   D6,0(A5,d2)                
   bra      end
end_wall_textures_small:
  endif

; here, no optimization...

  ifeq wall_opti-off

   cmp      #height,D5
   bge      wall_textures_big
   move.w   D5,D6            ; top->D2
   asr.w    #1,D6
   move.w   #height/2,D2
   sub.w    D6,D2

   cmp      #texturing_limit,d5
   ble      wall_textures_small
   bra      wall_textures_normal

wall_textures_big:

\init
   movem.l d0-d4,-(a7)
   move.l  plane_ptr,a2             ;
   move.w  d0,d6                    ;
   asr.w   #3,d0                    ;
   add.l   d0,a2                    ;
   and.w   #8-1,d6                  ;  adresses of begening in a2 and of end
   bitchg  d6,a2                    ;  in a3 ( adresses in the screen )
   move.l  a2,a3                    ;  number of bit to set in screen in d6.b
   add.l   #height*30,a3            ;
   move.l  #wall_texture_size*256,d4   ;  step * 256 -> d4.w
   move.w  d5,d2                    ;
   divu.w  d2,d4                    ;
   ext.l   d4
   move.w  d4,d2                    ;
   mulu.w  #height,d2               ;

   move.w  #wall_texture_size/2,d5
   asr.w   #8,d2
   asr.w   #1,d2
   sub.w   d2,d5
   asl.l   #_wall_texture_size,d5
   ext.l   d5

   lea     textures(pc),a1         ;
   add.l   d5,a1                   ;
   move.w  d3,d1                   ;
   asr.w   #3,d1                   ;  adress of begening in texture
   ext.l   d1                      ;  in a1 
   and.w   #8-1,d3                 ;  and bit to test in texture in d3.b
   bitchg  d3,d1                   ;
   add.l   d1,a1                   ;


   move.w  #0,d2
\loop
   move.w  d2,d5
   asr.w   #8,d5
   asl.w   #_wall_texture_size,d5
   ext.l   d5
   btst.b  d3,0(a1,d5)
   beq     \white
\black
   bset.b  d6,(a2)
;   bra     \end_pixel
\white
; nothing...
\end_pixel
   add.w   d4,d2
   add.l   #30,a2
   cmp.l   a2,a3
   bne     \loop
   movem.l (a7)+,d0-d4
   bra end
end_wall_textures_big:

wall_textures_normal:

; this  texturing subroutine uses as internal variables
; a1: adress of begening in texture
; a2: adress of begening in screen
; a3: adress of end in screen
; d0: used as a temporary register... ( destroyed ) 
; d2: temporary counter
; d3: bit number to test in texture
; d4: step * 256
; d5: offest in texture
; d6: bit number to set in screen

; the input must be:
; d0: the line number to display
; d2: top
; d3: texture line number
; d5: bottom
; on the stack: height...

; as an output, this routine will destroy d5/d6 and a1/a3

   move.w   d5,-(a7)
   add.w    D2,D5             ; bottom->D5

\init
   movem.l d0-d4,-(a7)
   lea     textures(pc),a1         ;
   move.w  d3,d6                   ;
   asr.w   #3,d6                   ;  adress of begening in texture
   ext.l   d6                      ;  in a1 
   and.w   #8-1,d3                 ;  and bit to test in texture in d3.b
   bitchg  d3,d6                   ;
   add.l   d6,a1                   ;

   move.l  plane_ptr,a2             ;
   move.w  d0,d6                    ;
   asr.w   #3,d0                    ;
   add.l   d0,a2                    ;
   and.w   #8-1,d6                  ;  adresses of begening in a2 and of end
   bitchg  d6,a2                    ;  in a3 ( adresses in the screen )
   move.l  a2,a3                    ;  number of bit to set in screen in d6.b
   move.w  d2,d4                    ;
   mulu.w  #30,d4                   ;
   add.l   d4,a2                    ;
   mulu.w  #30,d5                   ;
   add.l   d5,a3                    ;

   move.w  #wall_texture_size*256,d4   ;  step * 256 -> d4.w
   move.w  5*4(a7),d2
   divu.w  d2,d4                    ;
   ext.l   d4                       ;

   move.w  #0,d2
\loop
   move.w  d2,d5
   asr.w   #8,d5
   asl.w   #_wall_texture_size,d5
   ext.l   d5
   btst.b  d3,0(a1,d5)
   beq     \white
\black
   bset.b  d6,(a2)
;   bra     \end_pixel
\white
; nothing...
\end_pixel
   add.w   d4,d2
   add.l   #30,a2
   cmp.l   a2,a3
   bne     \loop
   movem.l (a7)+,d0-d4
   add.l   #2,a7
   bra end
end_wall_textures_normal:


wall_textures_small:
   add.w    D2,D5             ; bottom->D5

   mulu.w   #30,D2
   add.l    plane_ptr,D2
   move.l   d2,a5
   move.w   D0,D3
   asr.w    #3,D3
   move.w   D0,D6
   and.w    #8-1,D6
   bitchg   d6,d3
   bset.b   D6,0(a5,d3)
   mulu.w   #30,D5
   move.l   plane_ptr,a5
   add.l    D3,D5
   bset.b   D6,0(A5,d5)                
   bra      end
end_wall_textures_small:
  endif

 endif
